//------------------------------------------------------------------------------
// GPL LICENSE (short)
//------------------------------------------------------------------------------
/*
 * Copyright (c) 2020 R1KO, vadrozh

 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#pragma semicolon 1
#pragma newdecls required

#include <sourcemod>
#include <sdktools>
#include <vip_core>

#define VIP_HEAVYARMOR	"HeavyArmor"

ConVar g_hAllowHAS;

public Plugin myinfo =
{
	name = "[VIP] Heavy Armor",
	author = "R1KO, vadrozh",
	description = "Выдача тяжелой брони VIP игрокам",
	version = "1.1.0",
	url = "https://hlmod.ru"
};

public APLRes AskPluginLoad2(Handle myself, bool late, char[] error, int err_max)
{
	if (GetEngineVersion() != Engine_CSGO)
	{
		strcopy(error, err_max, "Plugin works only with CS:GO.");
		return APLRes_Failure;
	}

	return APLRes_Success;
}

public void OnPluginStart()
{	
	g_hAllowHAS = FindConVar("mp_weapons_allow_heavyassaultsuit");
	if (!g_hAllowHAS)
		SetFailState("Can't get mp_weapons_allow_heavyassaultsuit ConVar.");
	else
		g_hAllowHAS.AddChangeHook(OnAllowHASChange);
	
	if(VIP_IsVIPLoaded())
		VIP_OnVIPLoaded();
}

public void OnPluginEnd()
{
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterMe") == FeatureStatus_Available)
		VIP_UnregisterMe();
}

public void OnConfigsExecuted()
{
	if (!g_hAllowHAS.BoolValue)
		g_hAllowHAS.BoolValue = true;
}

public void OnAllowHASChange(ConVar convar, char[] oldValue, char[] newValue) { OnConfigsExecuted(); }

public void VIP_OnVIPLoaded() { VIP_RegisterFeature(VIP_HEAVYARMOR, BOOL); }

public void VIP_OnPlayerSpawn(int iClient, int iTeam, bool bIsVIP)
{
	if(bIsVIP && VIP_IsClientFeatureUse(iClient, VIP_HEAVYARMOR))
		GivePlayerItem(iClient, "item_heavyassaultsuit");
}